/*
 * Copyright (c) 2000 Greg Haerr <greg@censoft.com>
 *
 * Monta Vista demo program for Microwindows
 */
#define MWINCLUDECOLORS
#include "windows.h"
#include "wintern.h"		/* for MwSetDesktopWallpaper*/
#include "graph3d.h"

#define CLIPDEMO	0	/* set for region clipping demo*/

extern MWIMAGEHDR image_hhpeng;
extern MWIMAGEHDR image_hhbanner;
extern MWIMAGEHDR image_hh100pct;
extern MWIMAGEHDR image_microwin;

#define APPCLASS	"test"
#define APPCHILD	"test2"

/* forward decls*/
LRESULT CALLBACK WndProc(HWND hwnd,UINT uMsg,WPARAM wp,LPARAM lp);
LRESULT CALLBACK ChildWndProc(HWND hwnd,UINT uMsg,WPARAM wp,LPARAM lp);

int
GsUserInit(int ac, char **av)
{
	/* test user init procedure - do nothing*/
	return 0;
}

int
RegisterAppClass(void)
{
	WNDCLASS	wc;

	MwButtonRegister(NULL);
	wc.style = CS_DBLCLKS | CS_VREDRAW | CS_HREDRAW;
	wc.lpfnWndProc = (WNDPROC)WndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = 0;
	wc.hIcon = 0; /*LoadIcon(GetHInstance(), MAKEINTRESOURCE( 1));*/
	wc.hCursor = 0; /*LoadCursor(NULL, IDC_ARROW);*/
	wc.hbrBackground = (HBRUSH)GetStockObject(LTGRAY_BRUSH);
	wc.lpszMenuName = NULL;
	wc.lpszClassName =  APPCLASS;
	RegisterClass( &wc);

	wc.lpfnWndProc = (WNDPROC)ChildWndProc;
	wc.lpszClassName =  APPCHILD;
	return RegisterClass( &wc);

	return 1;
}

HWND
CreateAppWindow(void)
{
	HWND	hwnd;
	int 	width, height;
	RECT 	r;
	static int nextid = 1;
	static int nextx = 60, nexty = 20;

	GetWindowRect(GetDesktopWindow(), &r);
	width = height = r.right / 2;

	hwnd = CreateWindowEx(0L, APPCLASS,
		"Microwindows Application",
		WS_OVERLAPPEDWINDOW | WS_VISIBLE,
		nextx, nexty, width, height,
		NULL, (HMENU)nextid++, NULL, NULL);

	if(hwnd && (nextid & 03) != 2) {
		CreateWindowEx(0L, APPCHILD,
			"",
			WS_BORDER | WS_CHILD | WS_VISIBLE,
			4, 4, width / 3, height / 3,
			hwnd, (HMENU)2, NULL, &image_hhpeng);
		CreateWindowEx(0L, APPCHILD,
			"",
			WS_BORDER | WS_CHILD | WS_VISIBLE,
			width / 3, height / 3, width / 3, height / 3,
			hwnd, (HMENU)3, NULL, &image_hhpeng);
		CreateWindowEx(0L, APPCHILD,
			"",
			WS_BORDER | WS_CHILD | WS_VISIBLE,
			width * 3 / 5, height * 3 / 5, width * 2 / 3, height * 2 / 3,
			hwnd, (HMENU)4, NULL, &image_hhpeng);
		CreateWindowEx(0L, "BUTTON",
			"OK",
			WS_CHILD | WS_VISIBLE,
			/*WS_CHILD | WS_VISIBLE | BS_AUTOCHECKBOX,*/
			width * 5 / 8, 10, 50, 14,
			hwnd, (HMENU)5, NULL, NULL);
	}
	nextx += 10;
	nexty += 10;
	return hwnd;
}

LRESULT CALLBACK
ChildWndProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
	HDC		hdc;
	RECT		rc;
	LPCREATESTRUCT	lpcs;
	PMWIMAGEHDR	pim;
	PAINTSTRUCT	ps;

	switch(msg) {
	case WM_CREATE:
		lpcs = (LPCREATESTRUCT)lp;
		pim = (PMWIMAGEHDR)lpcs->lpCreateParams;
		SetWindowLong(hwnd, GWL_USERDATA, (DWORD)pim);
		/* kluge fix for hhpeng*/
		if(pim == &image_hhpeng) {
		hwnd->winrect.right = hwnd->winrect.left + pim->width + 2;
		hwnd->clirect.right = hwnd->clirect.left + pim->width;
		//SetWindowPos(hwnd, HWND_TOP, 0, 0, pim->width, pim->height,
			//SWP_NOMOVE|SWP_NOZORDER);
		}
		break;

	case WM_PAINT:
		hdc = BeginPaint(hwnd, &ps);
		GetClientRect(hwnd, &rc);
		DrawDIB(hdc, rc.left, rc.top, 
			(PMWIMAGEHDR)GetWindowLong(hwnd,GWL_USERDATA));
		EndPaint(hwnd, &ps);
		break;
	default:
		return DefWindowProc(hwnd, msg, wp, lp);
	}
	return 0;
}

LRESULT CALLBACK
WndProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
	PAINTSTRUCT	ps;
	HDC		hdc;
	RECT		rc;
	int		id;
	static vec1 	gx, gy;
	static POINT	mousept;
	static int	countup = 1;

	switch( msg) {
	case WM_CREATE:
		SetTimer(hwnd, 1, 100, NULL);
		mousept.x = 60;
		mousept.y = 20;
		break;

	case WM_TIMER:
		GetClientRect(hwnd, &rc);
		if(countup) {
			mousept.y += 20;
			if(mousept.y >= rc.bottom) {
				mousept.y -= 20;
				countup = 0;
			}
		} else {
			mousept.y -= 20;
			if(mousept.y < 20) {
				mousept.y += 20;
				countup = 1;
			}
		}
		SendMessage(hwnd, WM_MOUSEMOVE, 0,
			MAKELONG(mousept.x, mousept.y));
		break;

	case WM_DESTROY:
		KillTimer(hwnd, 1);
		break;

	case WM_ERASEBKGND:
		if((GetWindowLong(hwnd, GWL_ID) & 03) == 1)
			return 1;
		return DefWindowProc(hwnd, msg, wp, lp);
	case WM_PAINT:
		hdc = BeginPaint(hwnd, &ps);

		id = (int)GetWindowLong(hwnd, GWL_ID) & 03;
		init3(hdc, id == 1? hwnd: NULL);
		switch(id) {
		case 0:
			rose(1.0, 7, 13);
			break;
		case 1:
			//look3(0.5, 0.7, 1.5);
			//look3(0.2, -2 * gy, 1.0+gx);
			look3(-2 * gx, -2 * gy, 1.2);
			drawgrid(-8.0, 8.0, 10, -8.0, 8.0, 10);
			break;
		case 2:
			setcolor3(BLACK);
			circle3(1.0);
			break;
		case 3:
			setcolor3(BLUE);
			daisy(1.0, 20);
			break;
		}

#if CLIPDEMO
		if(id == 1) {
			HRGN	hrgn, hrgn2;

			/* create circular clip region for effect*/
			GetClientRect(hwnd, &rc);
			InflateRect(&rc, -80, -80);
			switch((int)GetWindowLong(hwnd, GWL_ID)) {
			default:
				hrgn = CreateEllipticRgnIndirect(&rc);
				break;
			case 5:
				hrgn = CreateRoundRectRgn(rc.left, rc.top,
					rc.right, rc.bottom, 100, 100);
				break;
			case 1:
				hrgn = CreateRectRgnIndirect(&rc);
				break;
			}

			/* erase background, clip out blit area*/
			GetClientRect(hwnd, &rc);
			hrgn2 = CreateRectRgnIndirect(&rc);
			SelectClipRgn(hdc, hrgn2);
			ExtSelectClipRgn(hdc, hrgn, RGN_XOR);
			DeleteObject(hrgn2);

			GetClientRect(hwnd, &rc);
			FillRect(hdc, &rc, GetStockObject(BLACK_BRUSH));

			/* clip in only blit area*/
			SelectClipRgn(hdc, hrgn);
			DeleteObject(hrgn);
		}
#endif /* CLIPDEMO*/

		paint3(hdc);
		EndPaint(hwnd, &ps);
		break;

	case WM_LBUTTONDOWN:
		break;

	case WM_MOUSEMOVE:
		if((GetWindowLong(hwnd, GWL_ID) & 03) == 1) {
			POINT pt;

			POINTSTOPOINT(pt, lp);
			GetClientRect(hwnd, &rc);
			gx = (vec1)pt.x / rc.right;
			gy = (vec1)pt.y / rc.bottom;
			InvalidateRect(hwnd, NULL, FALSE);
			mousept.x = pt.x;
			mousept.y = pt.y;
		}
		break;

	default:
		return DefWindowProc( hwnd, msg, wp, lp);
	}
	return( 0);
}

int WINAPI 
WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine,
	int nShowCmd)
{
	MSG 	msg;
	HWND	hwnd;
	RECT	rc;
	int	h, w;

	RegisterAppClass();
	GetWindowRect(GetDesktopWindow(), &rc);

	/* create penguin window*/
	w = image_hh100pct.width;
	h = image_hh100pct.height;
	CreateWindowEx(0L, APPCHILD, "", WS_BORDER | WS_VISIBLE,
		rc.right-w-1, rc.bottom-h-1, w, h,
		GetDesktopWindow(), (HMENU)1000, NULL, &image_hh100pct);

	/* create side banner*/
	w = image_hhbanner.width;
	h = image_hhbanner.height;
	CreateWindowEx(0L, APPCHILD, "", WS_VISIBLE,
		0, 0, w, h,
		GetDesktopWindow(), (HMENU)1001, NULL, &image_hhbanner);

	CreateAppWindow();
	CreateAppWindow();
	CreateAppWindow();
	CreateAppWindow();
	CreateAppWindow();
	CreateAppWindow();
	CreateAppWindow();
	CreateAppWindow();
	hwnd = CreateAppWindow();
	GetWindowRect(hwnd, &rc);
	OffsetRect(&rc, 50, 50);
	MoveWindow(hwnd, rc.left, rc.top, rc.bottom-rc.top,
		rc.right-rc.left, TRUE);

	/* set background wallpaper*/
	MwSetDesktopWallpaper(&image_microwin);

	/* type ESC to quit...*/
	while( GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return 0;
}
